##############################################################################
#    Copyright (C) 2001  MMmanager.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################
"""
    Portal folders organize content.
"""
ADD_FOLDERS_PERMISSION = 'Add portal folders'

import Globals, re, base64, marshal, string
from Products.CMFCore import CMFCorePermissions

from Products.CMFCore.CMFCorePermissions import AddPortalFolders
from Products.CMFCore.CMFCorePermissions import AddPortalContent
from Products.CMFCore.CMFCorePermissions import ViewManagementScreens
from Products.CMFCore.CMFCorePermissions import View, ModifyPortalContent
from Products.CMFCore.utils import getToolByName
from Globals import DTMLFile
from OFS.DTMLMethod import DTMLMethod
from AccessControl import getSecurityManager, ClassSecurityInfo
from Acquisition import aq_base
from Products.CMFCore.PortalFolder import PortalFolder
from Products.CMFCore.PortalFolder import manage_addPortalFolder
from OFS.Folder import Folder
from DocumentTemplate.DT_Util import html_quote
from urllib import quote
import zLOG
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
from Products.CMFCalendar.Event import Event

try:
    from cStringIO import StringIO
except ImportError:
    from StringIO import StringIO

# Factory type information -- makes PortalBTreeFolder objects play nicely
# with the Types Tool (portal_types)
factory_type_information =  {
     'id': 'CMFEventFolder',
     'meta_type': 'CMF Event Folder',
     'description': 'Use folders to put content in categories.',
     'product': 'MMMCore',
     'icon': 'folder_icon.gif',
     'factory': 'manage_addCMFEventFolder',
     'filter_content_types': 0,
     'immediate_view': 'folder_contents',
     'actions': 
            ({'name': 'View',
              'action': 'folder_contents',
              'permissions': ('View',),
              'category': 'folder'},
             {'name': 'Change Folder',
              'action': 'folder_edit_form',
              'permissions': ('Manage properties',),
              'category': 'folder'},
             )
     }

listtext0 = '''<select name="ids:list" multiple size="%s">
'''
listtext1 = '''<option>%s</option>
'''
listtext2 = '''</select>
'''

_marker = []  # Create a new marker object.

try:
    higher_getattr = PortalFolder.inheritedAttribute('__getattr__')
except:
    def higher_getattr(self, name):
        raise AttributeError, name

class CMFEventFolder( PortalFolder, Event ):
    """
        Like a PortalFolder but uses a BTree for storage with
        appropriate management UI.
    """
    meta_type = 'CMF Event Folder'
    portal_type = 'Folder'

    manage_options=(
        ({'label':'Contents', 'action':'manage_main',},
         ) + Folder.manage_options[1:]
        )

    security = ClassSecurityInfo()

    description = ''


    def __init__( self, id, title='' ):
        # I can't figure out how to call two overridden __init__ methods
        # using inheritedAttribute, so I'll just duplicate their contents
        # here.
        #BTreeFolder.__init__(self)
        #self._tree = BTree()
        #PortalFolder.__init__(self, id, title)
	Event.__init__(self, id, title)
        self.id = id
        self.title = title

    
#    def allowedContentTypes( self ):
#	"""
#	 List types allowed in this folder.
#	 Medianets are only allowed to contain Logics
#	"""
#
#	result = []
#	portal_types = getToolByName(self, 'portal_types')
#	for contentType in portal_types.listTypeInfo():
#	  if contentType.content_meta_type == 'MediaManager Server Logic':
#            result.append(contentType)

    def edit(self, title=None
    		, description=None
		, eventType=None
		, effectiveDay=None
		, effectiveMo=None
		, effectiveYear=None
		, expirationDay=None
		, expirationMo=None
		, expirationYear=None
		, start_time=None
		, stop_time=None
		, location=None
		, contact_name=None
		, contact_email=None
		, contact_phone=None
		, event_url=None
		):

		Event.edit(self, title, description, eventType, effectiveDay, effectiveMo, effectiveYear, expirationDay, expirationMo, expirationYear
		, start_time, stop_time, location, contact_name, contact_email, contact_phone, event_url)

    security.declareProtected(View, 'SearchableText')
    def SearchableText(self):
        return "%s %s" % (self.Title(), self.Description())

    security.declareProtected(ModifyPortalContent, 'indexObject')
    def indexObject(self):
	catalog = getToolByName(self, 'portal_catalog', None)
	if catalog is not None:
	  catalog.indexObject(self)

    security.declareProtected(ModifyPortalContent, 'unindexObject')
    def unindexObject(self):
	catalog = getToolByName(self, 'portal_catalog', None)
	if catalog is not None:
	  catalog.unindexObject(self)

    security.declareProtected(ModifyPortalContent, 'reindexObject')
    def reindexObject(self):
	catalog = getToolByName(self, 'portal_catalog', None)
	if catalog is not None:
	  catalog.reindexObject(self)
	
     
    security.declareProtected(AddPortalFolders, 'manage_addCMFEventFolder')
    def manage_addCMFEventFolder(self, id, title='', REQUEST=None):
        """Add a new Event Folderr object with id *id*.
        """
        ob = CMFEventFolder(id, title)
        self._setObject(id, ob)
        if REQUEST is not None:
            return self.folder_contents(
                self, REQUEST, portal_status_message="Folder added")
    
    security.setPermissionDefault(AddPortalContent, ('Owner','Manager'))
    security.setPermissionDefault(AddPortalFolders, ('Owner','Manager'))


manage_addCMFEventFolder = CMFEventFolder.manage_addCMFEventFolder
manage_addCMFEventFolderForm = DTMLFile( 'folderAdd', globals() )

Globals.InitializeClass(CMFEventFolder)

# PortalContent classes need to be registered.  This installs the
# class's factory method and icon.
from Products.CMFCore.register import registerPortalContent
registerPortalContent(CMFEventFolder,
                      constructors=(CMFEventFolder.manage_addCMFEventFolder,),
                      action='manage_addCMFEventFolderForm',
                      icon="folder_icon.gif",
                      productGlobals=globals())
