##############################################################################
#    Copyright (C) 2001  MMmanager.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################
"""
"""

ADD_CONTENT_PERMISSION = 'Add portal content'

import Globals
import zLOG
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFCore.CMFCorePermissions import ManageProperties
from AccessControl import ClassSecurityInfo
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
from MasterFile import MasterFile
from General import TimeStamp
import General 

factory_type_information = {
      'id': 'MediaClip',
      'meta_type': 'Media Manager Clip',
      'description': 'Use clip to make new Media Clip',
      'product': 'MMMCore',
      'icon': 'clip_icon.png',
      'factory': 'addMediaClip',
      'filter_content_types': 0,
      'immediate_view': 'mediaclip_edit_form',
      'actions': 
	      ({'name': 'View',
	        'action': 'mediaclip_view',
		'permissions': ('View',),
		'category': 'object'},
	       {'name': 'Edit',
	        'action': 'mediaclip_edit_form',
		'permissions': ('Modify portal content',),
		'category': 'object'})
       }


class MediaClip( PortalContent
          , DefaultDublinCoreImpl
          ):
    """
        A Link
    """

    meta_type='Media Manager Clip'
    portal_type='Object'
    effective_date = expiration_date = None
    _isDiscussable = 1

    tcin = TimeStamp()
    tcout = TimeStamp()
    link  = ''
    altlink = ''
    masterfile = None
    body = ''
    smilname = ''
    rpmname = ''
    identifier = ''
    
    security = ClassSecurityInfo()

    def __init__( self
                , id
                , title=''
                , description=''
                ):
        DefaultDublinCoreImpl.__init__(self)
        self.id=id
        self.title=title
        self.description=description
	zLOG.LOG("MediaCinema", -100, "Made MasterFile %s" % (id))

    def setMasterFile(self, masterfile):
        """
	  Sets the master file to the one specified in
	  pMasterFile.
	  Param: pMasterFile - Either a string with the full path to
	  the masterfile or a MasterFile object.
	"""
        if not General.isinstance( masterfile, MasterFile):
	  zLOG.LOG("MediaClip", 0, "MasterFile: %s" % (masterfile))
	  masterfile = self.restrictedTraverse(masterfile)

	if not General.isinstance( masterfile, MasterFile):
	  raise "Incorrect master file"

        self.masterfile = masterfile
	zLOG.LOG("Clip", 0, "%s %s" % (self.masterfile, masterfile))
	self._p_changed = 1
	

    def getMasterFile(self):
	return self.masterfile

    def setTimeCodes(self, tcin, tcout):
	"""
	 Sets the Time clip data.
	"""
        if General.isinstance(tcin, TimeStamp):
	  self.tcin = tcin
	else:
	  self.tcin = TimeStamp(tcin)

	if General.isinstance(tcout, TimeStamp):
	  self.tcout = tcout
	else:
	  self.tcout = TimeStamp(tcout)

    def editLink(self, link, altlink):
	self.link = link
	self.altlink = altlink

	
    def SearchableText(self):
        """
            text for indexing
        """
        return "%s %s" % (self.title, self.description)

    def editClip(self, body=None, identifier=None, smilname=None, rpmname=None):
	if body is not None:
	   self.body = body

	if identifier is not None:
	   self.identifier = identifier

	if smilname is not None:
	   self.smilname = smilname

	if rpmname is not None:
	   self.rpmname = rpmname

def addMediaClip(self, id, title='', REQUEST=None):
	ob=MediaClip(id,title)
	self._setObject(id, ob)

Globals.InitializeClass(MediaClip)

from Products.CMFCore.register import registerPortalContent
registerPortalContent(MediaClip,
                      constructors=(addMediaClip,),
		      action='mediaclip_edit_form',
		      icon='clip_icon.png')
