##############################################################################
#    Copyright (C) 2001  MMmanager.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################
"""
"""

ADD_CONTENT_PERMISSION = 'Add portal content'

import zLOG
import Globals
from Globals import PersistentMapping, MessageDialog
from OFS.content_types import guess_content_type
from Persistence import Persistent
from types import *
from DateTime.DateTime import DateTime
from General import *
from os.path import join, isfile


from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFCore.CMFCorePermissions import ManageProperties
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFCore.WorkflowCore import WorkflowMethod

from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
from Products.CMFDefault.utils import tuplize

from AccessControl import ClassSecurityInfo, getSecurityManager
from MedianetFolder import MedianetFolder

import urllib, os, string

NO_BACKUPS = 0
BACKUP_ON_DELETE = 1
ALWAYS_BACKUP = 2
UNDO_POLICY = BACKUP_ON_DELETE
#bad =' ()[]{}~J~Z~_~N~^'
#good='_______AAAAAAaaaaaaCcEEEEeeeeeIIIIiiiiNnOOOOOOooooooSssUUUUuuuuYYyyZz'
#TRANSMAP=string.maketrans(bad, good)

factory_type_information = {
      'id': 'MasterFile',
      'meta_type': 'Media Manager Master File',
      'description': 'Use master file to store link to files',
      'product': 'MMMCore',
      'icon': 'file_icon.gif',
      'factory': 'addMasterFile',
      'filter_content_types': 0,
      'immediate_view': 'masterfile_edit_form',
      'actions': 
	      ({'name': 'View',
	        'action': 'masterfile_view',
		'permissions': ('View',),
		'category': 'object'},
	       {'name': 'Edit',
	        'action': 'masterfile_edit_form',
		'permissions': ('Modify portal content',)})
       }

class MasterFileObject(Persistent):
    masterFile = None
    relativeTime = None

    security = ClassSecurityInfo()
    
    def _datify( self, attrib):
      if attrib == 'None':
        attrib = TimeStamp()
      elif not isinstance( attrib, TimeStamp ):
	if attrib is not None:
	  attrib = TimeStamp( attrib )
      return attrib

    def __init__(self, masterFile, logic, time):
      self.masterFile = masterFile
      self.logic = logic
      self.relativeTime = self._datify(time)

    security.declarePublic('getURL')
    def getURL(self):
      logic = self.masterFile.medianet[self.logic]
      return "%s://%s:%s%s%s%s" % (logic.protocol, logic.host, logic.port, logic.path, self.masterFile.filename, logic.ekstension)

    security.declarePublic('getRelated')
    def getRelated(self):
      logic = self.masterFile.medianet[self.logic]
      return "%s://%s%s%s%s" % (logic.protocol, logic.ppv_serverid, logic.path, self.masterFile.filename, logic.ekstension)

    security.declarePublic('getTime')
    def getTime(self):
      return self.relativeTime


class MasterFile( PortalContent
          , DefaultDublinCoreImpl,
	  Playable
          ):
    """
        A Link
    """

    meta_type='Media Manager Master File'
    portal_type='Object'
    effective_date = expiration_date = None
    _isDiscussable = 1
    encoder_start = ''
    reg_bgcolor = ''
    reg_xstart = ''
    reg_ystart = ''

    medianet = None

    security = ClassSecurityInfo()

    _repository = ['var','real']

    def __init__( self
                , id
                , title=''
                , description=''
		, xsixe=''
		, ysize=''
		, filename=''
		, content_type=''
                ):
        DefaultDublinCoreImpl.__init__(self)
        self.id=id
        self.title=title
        self.logics = {} 
        self.description=description
	self.xsize=0
	self.ysize=0
	self.filename=self._get_ufn()
	self.content_type=''
	zLOG.LOG("MasterFile", -100, "Made MasterFile %s" % (id))

	reposit=self._reposit_path()
	if os.path.exists(reposit) != 1:
	   mkdirExec='Cannot create directory: '
	   try:
	      os.mkdir(reposit)
	   except:
	      raise mkdirExec, reposit

	udir = str(getSecurityManager().getUser())
	ureposit = join(reposit, udir)
	if os.path.exists(ureposit) != 1:
	   mksubdirExec='Cannot create sub directory: '
	   try:
	      os.mkdir(ureposit)
	   except:
	      raise mksubdirExec, ureposit

    def issubclass(self, class1, class2):
	if type(class1) is ClassType and type(class2) is ClassType:
	  return __builtin__.issubclass(class1, class2)

        elif hasattr(class1, '__bases__') and hasattr(class2, '__bases__'):
	  stack = [class1]
	  while stack:
            if stack[0] is class2:
	      return 1
            stack.extend(list(stack[0].__bases__))
	    del stack[0]
	  else:
            return 0
     
        else:
	  raise TypeError, "arguments must be class or ExtensionClass objects"

    def isinstance(self, object, klass):
	if type(klass) is TypeType:
          return __builtin__.isinstance(object, klass)
        elif hasattr(object, '__class__'):
          zLOG.LOG("Serert", 0, "Class: %s" % (object.__class__))
	  return self.issubclass(object.__class__, klass)
        else:
	  return 0

    def setMedianet( self, medianet ):
	if not self.isinstance ( medianet, MedianetFolder ):
	  zLOG.LOG("SLDFDS", 0, "Medianet: %s" % (medianet))
	  medianet = self.restrictedTraverse(medianet)

	if not self.isinstance ( medianet, MedianetFolder ):
	  raise "Incorrect medianet, Medianet: %s" % (medianet)
	self.medianet = medianet
	self._p_changed = 1
   
    security.declarePublic('DumpLOG')
    def DumpLOG(self, REQUEST):
	zLOG.LOG("MasterFile", 0, "%s" % (str(REQUEST)))

    def listLogics( self ):
	"""
	  List All offsets available
	"""
	zLOG.LOG("MasterFile", -100, "Listing logics\nCurrent:\n%s" % (self.logics.keys()))
	return self.logics.keys()

    def lookupPlayerSource(self):
	return self.logics.values()[0].getURL() 

    security.declareProtected(ManageProperties, 'setFilename')
    def setFilename(self, filename):
        self.filename = filename

    security.declareProtected(View, 'checkLogic')
    def checkLogic( self, id ):
	"""
	   Checks if the specified logic applies to this masterfile
	"""
	zLOG.LOG("MasterFile", -100, "Checking logic %s return: %s" % (id, self.logics.has_key(id)))
	return self.logics.has_key(id)

    security.declareProtected(View, 'getLogic')
    def getLogic( self, id ):
	zLOG.LOG("MasterFile", -100, "Fetching logic %s return: %s" % (id, self.logics[id]))
	return self.logics[id]
	
    security.declareProtected(ManageProperties, 'assignLogic')
    def assignLogic( self, id, offset ):
	"""
	   Assigns an Logic and an Offset to the Masterfile
	"""
	#raise "DEBUG", "Assign %s to %s" % (id, offset)
	zLOG.LOG("MasterFile", -100, "Assign %s to %s" % (id, offset))
	self.logics[id] = MasterFileObject(masterFile = self, logic=id, time=offset)
	self._p_changed = 1

    security.declareProtected(ManageProperties, 'clearLogics')
    def clearLogics( self ):
	#raise "DEBUG", "Clear %s" % (self.logics.values())
	zLOG.LOG("MasterFile", -100, "Clearing logics\nOld values:\n%s" % (self.logics.values()))
	self.logics.clear()
	self._p_changed = 1
	
    def setEncoderStart(self, enc_start=None):
	if enc_start is not None:
	   self.encoder_start = enc_start

    def SearchableText(self):
        """
            text for indexing
        """
        return "%s %s" % (self.title, self.description)

    def Related(self):
	"""
	  returns a list of urls related to this object.
	  For a masterfile this is all urls to the server files.
	"""
	relate = []
	for logic in self.logics.values():
	    relate.append(logic.getRelated())
	return tuplize('related', relate)

    def editMasterFile(self, title=None, description=None, xsize=None, ysize=None, reg_xstart=None, reg_ystart=None, reg_bgcolor=None, filename=None):
	if title is not None:
	   self.title=title
		    
	if description is not None:
	   self.description=description

        if xsize is not None:
	   self.xsize=xsize

        if ysize is not None:
	   self.ysize=ysize

	if reg_xstart is not None:
	   self.reg_xstart = reg_xstart

	if reg_ystart is not None:
	   self.reg_ystart = reg_ystart

	if reg_bgcolor is not None:
	   self.reg_bgcolor = reg_bgcolor

	if filename is not None:
	   self.filename = filename

    def cb_isMoveable(self):
	return 0

    def cb_isCopyable(self):
	"""
	  You can copy this object
	"""
	return 1

	#Added by Gitte 17/7-2001
    
    def editFile(self, file=''):
	if file.filename != '' and file.read() != '':
	    self.manage_file_upload(file)
	self.setFormat(self.content_type)
    
    def manage_file_upload(self, file='', content_type='', REQUEST=None):
	if type(file) is not type(''):
	   reposit=self._reposit_path()
	   if self.filename!='':
	      new_writefn=self._get_writepathfn(file)
	      new_fn=self.filename
	   else:
	      fileError = 'Masterfileobject has no filename'
	      if self.filename=='' or file.filename=='':
	         raise fileError, 'Filename attrib: %s' % (self.filename)
	      else:
		 raise fileError, 'Files filename attrib: %s' % (file.filename)
	        
	   try:
	      fp=open(join(reposit, new_writefn), 'wb')
	      self._copy_data(file, fp)
	      fp.close()
	   except:
	      raise 'Cannot write: ', ("%s (%s)" %(self.id, new_writefn))
           self.content_type=self._get_content_type(file, file.read(100),
                                      self.id, content_type or self.content_type)
	   self.filename=new_fn
	    
    def _copy_data(self, instream, outstream):
        if type(instream) is StringType:
           outstream.write(instream)
	else:
	   try:
	      instream.seek(0,2)
	      size=instream.tell()
	      instream.seek(0)
	      blocksize=2<<16
	      pos=0
	      while pos<size:
	         outstream.write(instream.read(blcksize))
	         pos=pos+blocksize
		 instream.seek(0)
	   except:
	      outstream.write(instream.read())
	
    def _get_writeufn(self):
	"""Creates a unique filename"""
	udir = str(getSecurityManager().getUser())
	reposit=self._reposit_path()
	ureposit=join(reposit, udir)
	time=int(DateTime().strftime('%m%d%H%M%S'))
        fn=join(ureposit, "%s_%d_%s"%(udir,time,self.id))
        while (isfile(fn) or isfile(fn+'.preview')
              or isfile(fn+'.undo') or isfile(fn+'.preview.undo')):
	   time=time+1
	   fn=join(reposit,"%s_%d_%s"%(udir,time,self.id))

	new_fn=fn+'.rm'
	 
	return new_fn

    def _get_ufn(self):
	"""Creates a unique filename"""
	udir = str(getSecurityManager().getUser())

        time=int(DateTime().strftime('%m%d%H%M%S'))
	fn="%s_%d_%s"%(udir,time,self.id)
	new_fn = join(udir, fn)
	
	correct_fn=new_fn+'.rm'
	
	return correct_fn

    def _get_writepathfn(self, file):
	"""Create a filename with the correct path"""
	udir = str(getSecurityManager().getUser())
	reposit=self._reposit_path()
	ureposit=join(reposit, udir)
	if self.filename=='':
	   new_fn=join(ureposit, file.filename)
	else:
	   new_fn=join(reposit, self.filename)

	return new_fn

    def _get_filename(self, file):
	"""Get filename + dir where file is putted"""
	udir = str(getSecurityManager().getUser())
	if file.filename == '':
	   time=int(DateTime().strftime('%m%d%H%M%S'))
	   fn="%s_%d_%s"%(udir,time,self.id)
	   new_fn=join(udir, fn)
	else:
	   new_fn = join(udir, file.filename)
	   
	return new_fn
	
  
    def _reposit_path(self):
        path=INSTANCE_HOME
	for item in self._repository:
	   path=join(path, item)
	return path

    def _get_content_type(self, file, body, id, content_type=None):
	"""Determine the mime-type"""
	headers=getattr(file, 'headers', None)
	if headers and headers.has_key('content_type'):
	   content_type=headers['content_type']
	else:
	   if type(body) is not type(''): body=body.data
	   content_type, enc=guess_content_type(getattr(file, 'filename', id), body, content_type)
	return content_type

def addMasterFile(self, id, title='', REQUEST=None):
	ob=MasterFile(id,title)
	self._setObject(id, ob)

Globals.InitializeClass(MasterFile)

from Products.CMFCore.register import registerPortalContent
registerPortalContent(MasterFile,
                      constructors=(addMasterFile,),
		      action='masterfile_edit_form',
		      icon='file_icon.gif')
