##############################################################################
# 
# Zope Public License (ZPL) Version 1.0
# -------------------------------------
# 
# Copyright (c) Digital Creations.  All rights reserved.
# 
# This license has been certified as Open Source(tm).
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 
# 1. Redistributions in source code must retain the above copyright
#    notice, this list of conditions, and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions, and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
# 
# 3. Digital Creations requests that attribution be given to Zope
#    in any manner possible. Zope includes a "Powered by Zope"
#    button that is installed by default. While it is not a license
#    violation to remove this button, it is requested that the
#    attribution remain. A significant investment has been put
#    into Zope, and this effort will continue if the Zope community
#    continues to grow. This is one way to assure that growth.
# 
# 4. All advertising materials and documentation mentioning
#    features derived from or use of this software must display
#    the following acknowledgement:
# 
#      "This product includes software developed by Digital Creations
#      for use in the Z Object Publishing Environment
#      (http://www.zope.org/)."
# 
#    In the event that the product being advertised includes an
#    intact Zope distribution (with copyright and license included)
#    then this clause is waived.
# 
# 5. Names associated with Zope or Digital Creations must not be used to
#    endorse or promote products derived from this software without
#    prior written permission from Digital Creations.
# 
# 6. Modified redistributions of any form whatsoever must retain
#    the following acknowledgment:
# 
#      "This product includes software developed by Digital Creations
#      for use in the Z Object Publishing Environment
#      (http://www.zope.org/)."
# 
#    Intact (re-)distributions of any official Zope release do not
#    require an external acknowledgement.
# 
# 7. Modifications are encouraged but must be packaged separately as
#    patches to official Zope releases.  Distributions that do not
#    clearly separate the patches from the original work must be clearly
#    labeled as unofficial distributions.  Modifications which do not
#    carry the name Zope may be packaged in any form, as long as they
#    conform to all of the clauses above.
# 
# 
# Disclaimer
# 
#   THIS SOFTWARE IS PROVIDED BY DIGITAL CREATIONS ``AS IS'' AND ANY
#   EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
#   PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL DIGITAL CREATIONS OR ITS
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# 
# 
# This software consists of contributions made by Digital Creations and
# many individuals on behalf of Digital Creations.  Specific
# attributions are listed in the accompanying credits file.
# 
##############################################################################
"""
"""

ADD_CONTENT_PERMISSION = 'Add portal content'

import Globals
import zLOG
from DateTime import DateTime
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFCore.CMFCorePermissions import ManageProperties
from AccessControl import ClassSecurityInfo
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
from Products.MMMCore.CMFEventFolder import CMFEventFolder
#from Products.CMFCalendar.Event import Event
#from Globals import PersistentList
from Products.CMFCore.WorkflowCore import afterCreate

from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.WorkflowCore import WorkflowAction, afterCreate
from Products.CMFCore.utils import getToolByName, tuplize
from os.path import join
from General import *

import os
import shutil

factory_type_information = {
      'id': 'MediaLiveEvent',
      'meta_type': 'Media Manager Live Event',
      'description': 'Use live events to make new Media Live Event',
      'product': 'MMMCore',
      'icon': 'event_icon.gif',
      'factory': 'addMediaLiveEvent',
      'filter_content_types': 0,
      'immediate_view': 'liveevent_edit_form',
      'actions': 
	      ({'name': 'View',
	        'action': 'liveevent_view',
		'permissions': ('View',),
		'category': 'object'},
	       {'name': 'Edit',
	        'action': 'liveevent_edit_form',
		'permissions': ('Modify portal content',),
		'category': 'object'},
	       {'name': 'Encode',
	        'action': 'liveevent_enc_form',
		'permissions': ('View',),
		'category': 'object'})
       }


class MediaLiveEvent( CMFEventFolder, Playable
          ):
    """
        A Link
    """

    meta_type='Media Manager Live Event'
    portal_type='Object'
    effective_date = expiration_date = None
    _isDiscussable = 1
    _isShow = 1
    encpass = ''
    xsize = ''
    ysize = ''
    bandwidth = ''
    audioformat = ''
    audience_rate = ''
    video_quality = ''
    logic = ''
    author = ''
    isArchived = 0
    transport = 'tcp'
    pixfile = ''
    pix_xsize = ''
    pix_ysize = ''
    pix_xstart = ''
    pix_ystart = ''
    pix_bgcolor = ''
    pix_encstart = ''
    root_xsize = ''
    root_ysize = ''
    root_bgcolor = ''
    usePixregion = ''

    _repository = ['var','real','encoder']

    def __init__( self
                , id
                , title=''
                , description=''
		, effective_date = None
		, expiration_date = None
		, start_date = str(DateTime())
		, end_date = str(DateTime())
		, location = ''
		, contact_name = ''
		, contact_email = ''
		, contact_phone = ''
		, event_url = ''
		, isArchived = 0
                ):
	CMFEventFolder.__init__(self, id, title)
	zLOG.LOG("MediaLiveEvent", -100, "Made MasterFile %s" % (id))

	reposit=self._reposit_path()
	wait_file='wait.rm'
	file_reposit=join(reposit, wait_file)

	self.setStartDate(DateTime(start_date))
	
	if os.path.exists(reposit)!=1:
	   mkdirExec='Cannot create directory: '
	   try:
	      os.mkdir(reposit)
	   except:
	      raise mkdirExec, reposit

        if os.path.exists(file_reposit)!=1:
	   self.filename=''
	   file_not_there='The file called wait.rm isnt located in your encoder dir. Please upload it to: '
	   raise file_not_there, reposit
   	else:
	   from AccessControl import getSecurityManager
	   username=str(getSecurityManager().getUser())
	   time=int(DateTime().strftime('%m%d%H%M%S'))
	   fn="%s_%d_%s_live.rm"%(username,time,self.id)
	   new_fnreposit=join(reposit,fn)
	   shutil.copyfile(file_reposit, new_fnreposit)
	   self.filename=fn
	   self.author=username
	   copy_time=str(DateTime().strftime('%Y'))
	   copy_text='Copyright %s'%(copy_time)
	   self.setRights(copy_text)
	   

    def SearchableText(self):
        """
            text for indexing
        """
        return "%s %s" % (self.title, self.description)

    def getRelated(self):
	if self.logic!='':
		l_path = str(self.logic)
		l_obj = self.aq_parent.restrictedTraverse(l_path)
		return "%s://%s/%s" % (l_obj.protocol, l_obj.ppv_serverid, self.filename)

    def Related(self):
	relate = []
	relate.append(self.getRelated())
	return tuplize('relate', relate)

    def edit_streaminfo(self
    			, encpass=None
			, xsize=None
			, ysize=None
			, bandwidth=None
			, audioformat=None
			, audience_rate=None
			, video_quality=None
			, logic=None
			, author=None
			, Rights=None
			, transport=transport
			):

		if encpass is not None:
			self.encpass=encpass
		if xsize is not None:
			self.xsize=xsize
		if ysize is not None:
			self.ysize=ysize
		if bandwidth is not None:
			self.bandwidth=bandwidth
		if audioformat is not None:
			self.audioformat=audioformat
		if audience_rate is not None:
			self.audience_rate=audience_rate
		if video_quality is not None:
			self.video_quality=video_quality
		if logic is not None:
			self.logic=logic
		if Rights is not None:
			self.setRights(Rights)
		if author is not None:
			self.author=author

		if transport is not None:
			self.transport=transport

    def set_LiveLogic(self, livelogic=None):
	if livelogic is not None:
		self.logic=livelogic

    def savePixfile(self, pixfile=None):
	if pixfile is not None:	
	   self.pixfile=pixfile

    def savePixBgColor(self, bgcolor=None):
	if bgcolor is not None:
	   self.pix_bgcolor = bgcolor

    def savePixXsize(self, xsize=None):
	if xsize is not None:
	   self.pix_xsize = xsize

    def savePixEncStart(self, enc_start=None):
	if enc_start is not None:
	   self.pix_encstart = enc_start

    def savePixYsize(self, ysize=None):
	if ysize is not None:
	   self.pix_ysize = ysize

    def saveRootXsize(self, root_width=None):
	if root_width is not None:
	   self.root_xsize = root_width

    def saveRootYsize(self, root_height=None):
	if root_height is not None:
	   self.root_ysize = root_height

    def saveRootBgColor(self, root_bgcolor=None):
	if root_bgcolor is not None:
	   self.root_bgcolor = root_bgcolor

    def setPixRegion(self, checkmark=None):
	if checkmark is not None:
	   self.usePixregion = checkmark

    def setLiveFilename(self, filename=None):
	if filename is not None:
	   self.filename = filename

    def archiveEvent(self):
	if self.isArchived == 0:
	   self.isArchived=1
	
    def unarchiveEvent(self):
	if self.isArchived == 1:
	   self.isArchived=0

    def _reposit_path(self):
	path=INSTANCE_HOME
	for item in self._repository:
	   path=join(path, item)
	return path

def addMediaLiveEvent(self, id, title='', start_date=str(DateTime()), end_date=str(DateTime()), REQUEST=None):
	ob=MediaLiveEvent(id,title,start_date=start_date, end_date=end_date)
	self._setObject(id, ob)

Globals.InitializeClass(MediaLiveEvent)

from Products.CMFCore.register import registerPortalContent
registerPortalContent(MediaLiveEvent,
                      constructors=(addMediaLiveEvent,),
		      action='liveevent_edit_form',
		      icon='event_icon.gif')
