##############################################################################
#    Copyright (C) 2001  MMmanager.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################

"""
"""

ADD_CONTENT_PERMISSION = 'Add portal content'

import Globals
import zLOG
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFCore.CMFCorePermissions import ManageProperties
from AccessControl import ClassSecurityInfo
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl


factory_type_information = {
      'id': 'MediaShow',
      'meta_type': 'Media Manager Show',
      'description': 'Use show to make new Media Show',
      'product': 'MMMCore',
      'icon': 'file_icon.gif',
      'factory': 'addMediaShow',
      'filter_content_types': 0,
      'immediate_view': 'mediashow_edit_form',
      'actions': 
	      ({'name': 'View',
	        'action': 'mediashow_view',
		'permissions': ('View',),
		'category': 'object'},
	       {'name': 'Edit',
	        'action': 'mediashow_edit_form',
		'permissions': ('Modify portal content',),
		'category': 'object'},
	       {'name': 'Add Clip',
	        'action': 'mediashow_add_clip_form',
		'permissions': ('Modify portal content',),
		'category': 'object'})
       }


class MediaShow( PortalContent
          , DefaultDublinCoreImpl
          ):
    """
        A Link
    """

    meta_type='Media Manager Show'
    portal_type='Object'
    effective_date = expiration_date = None
    _isDiscussable = 1

    security = ClassSecurityInfo()

    def __init__( self
                , id
                , title=''
                , description=''
                ):
        DefaultDublinCoreImpl.__init__(self)
        self.id=id
        self.title=title
        self.clips = [] 
        self.description=description
	zLOG.LOG("MediaShow", -100, "Made MasterFile %s" % (id))

    def listClips( self ):
	"""
	  List All offsets available
	"""
	zLOG.LOG("MediaShow", zLOG.INFO, "Listing logics\nCurrent:\n%s" % (self.clips))
	return tuple(self.clips)

    security.declareProtected(View, 'lookup')
    def lookup(self, userset=None):
        """
	  returns the URL nedded
	"""
	zLOG.LOG("MediaShow", -100, "Lookup called")
	#ob = self.unrestrictedTraverse('../..', default=None)
	#if ob is not None:
	relative = "%s" % (self.id)
	ob = self.unrestrictedTraverse('..', default=None)
	if ob is None:
	    raise "DEBUG", "MasterFile not contained in Medianet"
	while not (ob.meta_type == "Media Manager Medianet"):
	    obn = ob.unrestrictedTraverse('..', default=None)
	    if obn is None:
                raise "DEBUG", "MasterFile not contained in Medianet"
	    if not (obn.meta_type == "Media Manager Medianet"):
		relative = "%s/%s" % (ob.id,relative)
            ob = obn 
	    #zLOG.LOG ("MasterFile", -100, "Found %s %s" % (ob.absolute_url(), ob.meta_type))

	return  ob.lookupMasterFile(object=self, name=relative, userset=userset)

    security.declareProtected(View, 'getClip')
    def getClip( self, pIndex ):
	index = int(pIndex)
	zLOG.LOG("MediaShow", zLOG.TRACE, "Fetching logic %s return: %s" % (index, self.clips[index]))
	return self.clips[index]
	
    security.declareProtected(ManageProperties, 'moveUp')
    def moveUp( self, pIndex ):
	"""
	"""
	index = int(pIndex)
	#raise "DEBUG", "Assign %s to %s" % (id, offset)
	zLOG.LOG("MediaShow", -100, "moveUp %s" % (index))
	if index>0 and index<len(self.clips):
	  old = self.clips[index-1]
	  self.clips[index-1] = self.clips[index]
	  self.clips[index] = old
	  self._p_changed = 1

    security.declareProtected(ManageProperties, 'moveDown')
    def moveDown( self, pIndex ):
        """
	"""
	index=int(pIndex)
	zLOG.LOG("MediaShow", zLOG.TRACE, "moveDown %s" % (index))
	if index<len(self.clips)-1 and index>=0:
	  old = self.clips[index+1]
	  self.clips[index+1] = self.clips[index]
	  self.clips[index] = old
	  self._p_changed = 1

    security.declareProtected(ManageProperties, 'delete')
    def delete( self, pIndex ):
        """
	"""
	index=int(pIndex)
	zLOG.LOG("MediaShow", zLOG.INFO, "delete %s %s" % (index, len(self.clips)))
	if index>=0 and index<len(self.clips):
	  del self.clips[index]
	  self._p_changed = 1
	  zLOG.LOG("MediaShow", zLOG.INFO, "Deleted %s" %(index))

    security.declareProtected(ManageProperties, 'append')
    def append( self, clip ):
	"""
	"""
	zLOG.LOG("MediaShow", zLOG.INFO, "append %s" % (clip))
	self.clips.append(clip)
	self._p_changed = 1

    def SearchableText(self):
        """
            text for indexing
        """
        return "%s %s" % (self.title, self.description)

def addMediaShow(self, id, title='', REQUEST=None):
	ob=MediaShow(id,title)
	self._setObject(id, ob)

Globals.InitializeClass(MediaShow)

from Products.CMFCore.register import registerPortalContent
registerPortalContent(MediaShow,
                      constructors=(addMediaShow,),
		      action='mediashow_edit_form',
		      icon='file_icon.gif')
